// Copyright (C) 2009 Playedit.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef ALBUM_SELECTOR_H
#define ALBUM_SELECTOR_H

#include "mtp_data_types.h"
#include "treeview.h"

#include <gtkmm/dialog.h>
#include <gtkmm/scrolledwindow.h>

class AlbumView : public TreeViewBase
{
	public:
		AlbumView();

		void PopulateStore(const std::vector<Gtk::TreeIter>& album_list);
		int GetSelectedIndex();

	private:
		void AlbumArtDataFunc(Gtk::CellRenderer *renderer,
				const Gtk::TreeIter& iter);
		void MusicNameDataFunc(Gtk::CellRenderer *renderer,
				const Gtk::TreeIter& iter);

		Gtk::CellRendererPixbuf m_AlbumArt;
		Gtk::CellRendererText m_MusicName;
};

class AlbumSelector : public Gtk::Dialog
{
	public:
		static int Run(const std::vector<Gtk::TreeIter>& album_list,
				const Glib::RefPtr<const track_t>& track);

	private:
		AlbumSelector(const std::vector<Gtk::TreeIter>& album_list,
				const Glib::RefPtr<const track_t>& track);

		// Descriptive labels
		Gtk::Label m_TrackName;
		Gtk::Label m_TrackArtist;
		Gtk::Label m_Description;

		// Album list
		Gtk::ScrolledWindow m_AlbumViewport;
		AlbumView* m_AlbumView;

		// Standard dialog buttons
		Gtk::Button m_ButtonCancel, m_ButtonOk;
};



#endif // ALBUM_SELECTOR_H
